/*************************************
 MultiLauncher 0.3.0 header file
 (C) 2005-2007 Hynek Sladky
 sladky@mujmail.cz
*************************************/

// ------------------------------------
// DEBUG log functions
// ------------------------------------
//void DEBUG (char *a, ...);
//void DEBUGm (char *a, ...);
// ====================================
// common definitions
// ------------------------------------
// database type definition
// ------------------------------------
#define AppID           'Mlnc'
#define RecentType      'RecA'
#define MLapps          "MLapps"
#define MLtasks         "MLtasks"
#define RecentName      "RecentApps"
// ------------------------------------
// feature defines
// ------------------------------------
#define FTR_BITS                1
// event notifications
#define CONTRAST_KEYS           0x00000001
#define SELECTION_KEYS          0x00000002
#define CMD_BAR_KEY             0x00000004
#define GRAFFITI_PATCH          0x00000008
#define GRAFFITI_CONTROL        0x00000010
#define KEYGUARD_ON             0x00000020
#define ALARMLOG_ON             0x00000040
#define DEBUGLOG_ON             0x00000080
// other setting
#define SCHEDULER_ON            0x00004000
#define MULTILAUNCHER_ON        0x00008000
// runtime flags
#define CONTRAST_REQUESTED      0x00010000
#define CONTRAST_DISPLAYED      0x00020000
#define OPTION_KEY              0x00100000
// ------------------------------------
// task feature assignment
// ------------------------------------
#define FTR_OFF                 10
#define FTR_KEYS                11
#define FTR_ALARM               12
#define FTR_STEP                13
#define FTR_APP                 14
// ------------------------------------
#define FTR_HANDLER_PROC        91
// ------------------------------------
// notification defines
// ------------------------------------
#define MLnotify        'MLno'
#define reqBrightness   (void*)1
#define reqKeyguard     (void*)2
// ------------------------------------
// other defines
// ------------------------------------
//#define MaxRecent       13
#define MaxRecent       26
// Treo650 Device ID
#ifndef kPalmOneDeviceIDTreo650
#define kPalmOneDeviceIDTreo650 'H102'
#endif
// ------------------------------------
// preference defines
// ------------------------------------
#define PREF_APP                0
#define PREF_SND                1
// ====================================
// type definitions
// ------------------------------------
// ML preference
// ------------------------------------
typedef struct {
  UInt16        bits;
  UInt16        tasknum;
  UInt16        stepnum;
} PrefsType;
// ------------------------------------
// sound preference backup
// ------------------------------------
typedef struct {
  ToneVolume soundOnVolume;
  Boolean soundOnVibrate;
  //Boolean soundOffVibrate;
} SoundPrefBackupType;
// ------------------------------------
// task planning
// ------------------------------------
enum {STEP_launch=0, STEP_event, STEP_text, STEP_phone, STEP_BT, STEP_alarm, STEP_keyguard, STEP_end};
// ------------------------------------
// step structure
// ------------------------------------
typedef struct {
  UInt16 delay;
  UInt16 action; // event - text - launch - Phone - BT - Alarm
  union {
    Char str[32]; // app name / field text
    UInt32 val;
    EventType event; // event data
    //...
  } data;
} stepType;
/********
popis kroku:
+999s launch <31chars>
+999s event <...odhaduju tak 63 znaku>
+999s text <31chars>
+999s phone OFF
+999s BT OFF
+999s alarms OFF
********/
#define STEP_TITLE      64
// ------------------------------------
// task structure
// ------------------------------------
#define TASKNAMELEN     32
enum {TASK_time=0, TASK_on, TASK_after};
typedef struct {
  Char name[TASKNAMELEN]; // task name
  UInt32 time; // start time
  UInt8 weekdays; // day flags Mo-Tue-We-Thu-Fr-Sa-Su
  UInt8 condition; // at time - after Off - while ON
  stepType step[0];
} taskType;
// ------------------------------------
// alarm structure
// ------------------------------------
typedef struct {
  UInt16 card;
  LocalID locid;
  UInt16 tasknum;
  DmOpenRef db;
  taskType *tptr;
  UInt16 stepcnt;
} alarmType;
// ------------------------------------
// database globals
// ------------------------------------
DmOpenRef               taskDB;
// ------------------------------------
// user events, launch codes, notifications
// ------------------------------------
//#define RunPreviousApp  (sysAppLaunchCmdCustomBase+1)
#define ShowRecentList  (sysAppLaunchCmdCustomBase+2)

#define frmGadgetSelectEvent    (firstUserEvent+1)
#define frmGadgetHoldEvent      (firstUserEvent+2)
// ====================================
// function prototypes
// ------------------------------------
Err EventHandler (SysNotifyParamType *params);
Err NotifyProc (SysNotifyParamType *params);
Err EnableMLauncher (UInt32 bits);
Int16 GetIrState (void);
void SetIrState (UInt16 state);
Int16 AlmState (Int16 state);
void SetTaskAlarm (UInt32 time, UInt16 task);
Int16 ExecAlarm (void);
void MemopadLog (Char *record, UInt8 type, Char *fmt, ...);

